// Scatter Selected 2.0.1
// Scatters objects with random translation, rotation and scaling.

// Scraped together by Stephan Möbius in August 2008.
// I highly welcome ALL feedback, error reports, suggestions and examples of how you used it.
// Email me: "moebius@anymotion.de"

// The sciprt works here in my Adobe InDesign CS3 (german)(windows XP) - I can't test it anywhere else.
// Please note that i am complete scripting beginner. You'll know if you take a look at the code.
// If it doesn't work for you it is VERY likely i will not be able to help at all.
// Be warned to extensivly test this script before you use it in production, if at all.

// - The script showcases the use of a ScriptUI floating palette,
// - Editboxes that handle measurement units (Pretty cool actually, Haven't found anything about it in any free script /snippet on the web yet),
// - the undoing of transformations, (Bummer, no negated matrices. They didn't work for me...)
// - saves a preferences file,
// - stores and retrieves an ARRAY of RECORDS object in a custom label.

// ++ ! WARNING ++ 
// The settings page is not working yet. This version scales selected textframes no matter what. 
// If a textframe has overset text or is part of a flow, there is ugly, non-undoable stuff happening to the text.

// Also, if you happen to scatter an object that sits very near the edge of the pasteboard, that is almost outside the pasteboard,
// it might happen that the object won't un-scatter. In that case move the object a bit inward and un-scatter again.

// Thanks to Gerald Singelmann, Olav Kvern, Dave Saunders and Martin Fischer. Thanks for posting all those examples.
// kind regards,
// Stephan

#targetengine "session"  
#target indesign

var ScriptName = "Scatter Selected";
var ScriptVersion = "2.0.1";
 
function ScatterSelected () { 
	this.windowRef = null; 
} 
 
ScatterSelected.prototype.run = function() { 
	var scaleLinked = new Boolean;
	scaleLinked = false;
	if (app.documents.length > 0) { //get users measurement preferences
		var userHoriz = getUnit(app.documents[0].viewPreferences.horizontalMeasurementUnits);
		var userVert =  getUnit(app.documents[0].viewPreferences.verticalMeasurementUnits);
	}
	else { var userHoriz = userVert = "pt"; }
	var images;
	if (( images = makeUIimages()) == null) return null; // Stop if any imagefile is missing
	
	// ++++ WINDOW CREATION ++++ Define components of a palette-type window (a modeless or floating dialog), 
	var res =
           "palette { \
				text: 'Scatter Selected 2.0.1', \
		   		properties:{ closeButton:true, maximizeButton:false,	\
				minimizeButton:false, resizeable:true }, \
				orientation:'column', spacing:3, margins:5, \
				alignChildren:['fill','top'], \
				Tabs: Group { \
					alignChildren:['fill','top'], \
					orientation:'stack', spacing:0, margins:0, \
					Scatter: Group { \
						alignChildren:['fill','top'], \
						orientation:'column', spacing:3, margins:5, \
						RotPnl: Panel { \
							text: 'Fixed Rotation °', \
							helpTip: 'Fixed rotation simply rotates the object for set degrees.', \
							minimumSize: [250, 20], \
							alignChildren:['fill','center'], \
							orientation: 'row', spacing:0, margins:8, \
							RotImage: Image {preferredSize: [24, 20], maximumSize: [26,20], minimumSize: [22,20] }, \
							RotSliderCtrl: Slider {preferredSize: [180, 20], value: 0, minvalue: -180, maxvalue: 180}, \
							RotEdittext: EditText {minimumSize:[48,20], maximumSize: [52,20], preferedSize: [50, 20], text: 0, active: true}, \
						}, \
						RndRotPnl: Panel { \
							text: 'Random Rotation (min°/max°)', \
							helpTip: 'Use the two sliders to set a range of minimum and maximum possible values for the random rotation. The random rotation will be added to the fixed rotation.', \
							alignChildren:['fill','center'], \
							orientation: 'column', spacing:2, margins:5, \
							separator: StaticText { preferredSize:[120,3] }, \
							RndRotMin: Group { \
									alignChildren:['fill','center'], spacing:0, margins:2, \
									RndRotMinImage: Image {preferredSize: [24, 20], maximumSize: [26,20], minimumSize: [22,20] }, \
									RndRotMinSliderCtrl: Slider {preferredSize: [180, 20], value: 0, minvalue: -180, maxvalue: 180}, \
									RndRotMinEdittext: EditText {minimumSize:[48,20], maximumSize: [52,20], preferedSize: [50, 20], text: 0} \
							} \
							RndRotMax: Group {  \
									alignChildren:['fill','center'], spacing:0, margins:2, \
									RndRotMaxImage: Image {preferredSize: [24, 20], maximumSize: [26,20], minimumSize: [22,20] }, \
									RndRotMaxSliderCtrl: Slider {preferredSize: [180, 20], value: 0, minvalue: -180, maxvalue: 180}, \
									RndRotMaxEdittext: EditText {minimumSize:[48,20], maximumSize: [52,20], preferedSize: [50, 20], text: 0} \
							}, \
						}, \
						RndTransPnl: Panel { \
							text: 'Random Translation', \
							helpTip: 'Set maxima for random X- and random Y-translations. If set to 10, the object will move in the range of -10 to 10 units. Enter any unit you like.', \
							alignChildren:['fill','center'], \
							orientation: 'column', spacing:2, margins:5, \
							separator: StaticText { preferredSize:[120,3] }, \
							RndTransX: Group { \
									alignChildren:['fill','center'], spacing:0, margins:2, \
									RndTransXImage: Image {preferredSize: [24, 20], maximumSize: [26,20], minimumSize: [22,20] }, \
									RndTransXSliderCtrl: Slider {preferredSize: [180, 20], value: 0, minvalue: 0, maxvalue: 100}, \
									RndTransXEdittext: EditText {minimumSize:[48,20], maximumSize: [52,20], preferedSize: [50, 20], text: 0} \
							} \
							RndTransY: Group { \
									alignChildren:['fill','center'], spacing:0, margins:2, \
									RndTransYImage: Image {preferredSize: [24, 20], maximumSize: [26,20], minimumSize: [22,20] }, \
									RndTransYSliderCtrl: Slider {preferredSize: [180, 20], value: 0, minvalue: 0, maxvalue: 100}, \
									RndTransYEdittext: EditText {minimumSize:[48,20], maximumSize: [52,20], preferedSize: [50, 20], text: 0} \
							}, \
						}, \
						RndScalePnl: Panel { \
							text: 'Random Scale X, Y (%)', \
							helpTip: 'Sliders are set to a maximum of 200%, but you may enter higher values manually.', \
							alignChildren:['fill','center'], \
							orientation: 'row', spacing:2, margins:5, \
							RndScale: Group { \
								alignChildren:['fill','center'], spacing:0, margins:2, orientation: 'column', \
								separator: StaticText { preferredSize:[120,5] }, \
								RndScaleX: Group { \
									alignChildren:['fill','center'], spacing:0, margins:2, orientation: 'row', \
									RndScaleXImage: Image {preferredSize: [24, 20], maximumSize: [26,20], minimumSize: [22,20] }, \
									RndScaleXMin: Group { \
											alignChildren:['fill','center'], spacing:0, margins:0, \
											RndScaleXMinSliderCtrl: Slider {preferredSize: [60, 20], value: 100, minvalue: 0, maxvalue: 200}, \
											RndScaleXMinEdittext: EditText {minimumSize:[48,20], maximumSize: [52,20], preferedSize: [50, 20], text: 0, percent:true} \
									} \
									RndScaleXMax: Group { \
											alignChildren:['fill','center'], spacing:0, margins:0, \
											RndScaleXMaxSliderCtrl: Slider {preferredSize: [60, 20], value: 100, minvalue: 0, maxvalue: 200}, \
											RndScaleXMaxEdittext: EditText {minimumSize:[48,20], maximumSize: [52,20], preferedSize: [50, 20], text: 0, percent:true} \
									} \
								} \
								RndScaleY: Group { \
									alignChildren:['fill','center'], spacing:0, margins:2, orientation: 'row', \
									RndScaleYImage: Image {preferredSize: [24, 20], maximumSize: [26,20], minimumSize: [22,20] }, \
									RndScaleYMin: Group { \
											alignChildren:['fill','center'], spacing:0, margins:0, \
											RndScaleYMinSliderCtrl: Slider {preferredSize: [60, 20], value: 100, minvalue: 0, maxvalue: 200}, \
											RndScaleYMinEdittext: EditText {minimumSize:[48,20], maximumSize: [52,20], preferedSize: [50, 20], text: 0, percent:true \
											} \
									} \
									RndScaleYMax: Group { \
											alignChildren:['fill','center'], spacing:0, margins:0, \
											RndScaleYMaxSliderCtrl: Slider {preferredSize: [60, 20], value: 100, minvalue: 0, maxvalue: 200}, \
											RndScaleYMaxEdittext: EditText {minimumSize:[48,20], maximumSize: [52,20], preferedSize: [50, 20], text: 0, percent:true \
											} \
									} \
								} \
							} \
							LinkScaleButton: IconButton {preferredSize: [24, 20], maximumSize: [26,20], minimumSize: [22,20], properties: {style:'toolbutton'}, \
							helpTip: 'Link ScaleX and ScaleY to scale objects proportionally.' } \
						}, \
					}, \
					SettingsPnl: Panel { \
						text: 'Settings', preferredSize: [250,282], \
						visible: false, \
						alignChildren:['fill','center'], \
						orientation: 'column', spacing:10, margins:10, \
						ScaleTextContent: Group { \
							alignChildren:['fill','top'], \
							chkScaleTextContent: Checkbox {value: false, minimumSize: [15,15], maximumSize: [15,15], preferredSize: [15,15], enabled: false }, \
							descScaleTextContent: StaticText { enabled: false, text: 'Scale textframes with content. Default: OFF. If enabled text in textframes will be scaled too.', properties: {multiline: true} } \
						} \
						ScaleOversettext: Group { \
							alignChildren:['fill','top'], \
							chkScaleOversetText: Checkbox {value: false, minimumSize: [15,15], maximumSize: [16,16], preferredSize: [15,15], enabled: false }, \
							descScaleOverseitText: StaticText { enabled: false, text: 'Scale textframes with content if they have overset text or if they are linked textframes. Default: OFF. Warning! Enabling this may result in chaotically scaled text.', properties: {multiline: true} } \
						} \
					} \
				}, \
				buttons: Group {  \
					alignment: ['fill','bottom'], \
					alignChildren:['fill','center'], \
					orientation: 'row', spacing:2, margins:0, \
					ResetButton: IconButton {preferredSize: [19, 19], properties: {style:'toolbutton'}, helpTip: 'Set all fields to 0' } \
					SettingsButton: IconButton {preferredSize: [24, 19], properties: {style:'toolbutton'}, helpTip: 'Settings' } \
                    scatterButton: Button { text:'Scatter!', properties:{name:'scatter'} }, \
					unscatterButton: Button { text:'Un-Scatter', properties:{name:'unscatter'} }, \
					doneButton: Button { text:'Done', properties:{name:'done'} } \
				} \
           }";

	// Create the dialog with the components
	var win = new Window(res);  
	// Additional settings, that i couldn't figure out how to do in creation above, i.e the IMAGES
	win.Tabs.Scatter.RndTransPnl.text = win.Tabs.Scatter.RndTransPnl.text + ' X(' + userHoriz + ') Y(' + userVert + ')';
	win.Tabs.Scatter.RotPnl.RotImage.image = images.rotate;
	win.Tabs.Scatter.RndRotPnl.RndRotMin.RndRotMinImage.image = images.rotmin;
	win.Tabs.Scatter.RndRotPnl.RndRotMax.RndRotMaxImage.image = images.rotmax;
	win.Tabs.Scatter.RndTransPnl.RndTransX.RndTransXImage.image = images.transX;
	win.Tabs.Scatter.RndTransPnl.RndTransY.RndTransYImage.image = images.transY;	
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXImage.image = images.scaleX;
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYImage.image = images.scaleY;	
	win.Tabs.Scatter.RndScalePnl.LinkScaleButton.image = images.unlinkScale;
	win.buttons.ResetButton.image = images.reset;
	win.buttons.SettingsButton.image = images.settings;

	this.windowRef = win;
	
	// ++++ PREFS ++++
	
	// create and or read preference file
	initPreferences();
	Preferences.winframeLocation = [0, 0]; // needed for first time run when prefs don't exist
	Preferences.RotEdittextPref = 0; // ...
	Preferences.RndRotMinEdittextPref = 0; // ...
	Preferences.RndRotMaxEdittextPref = 0; // ..
	Preferences.RndTransXEdittextPref = 0; // .
	Preferences.RndTransYEdittextPref = 0;
	Preferences.RndScaleXMinEdittextPref = 100; // .
	Preferences.RndScaleXMaxEdittextPref = 100; // .
	Preferences.RndScaleYMinEdittextPref = 100; // .
	Preferences.RndScaleYMaxEdittextPref = 100; // .
	readPreferences(); // try to read preference file now
	
	// Update Edittextboxes from Preferences...
	PrepVariablesFromPrefs(win, Preferences);
	// Update the Sliders from the value of their editboxes.
	updateSliders(win); 
	
		
	// ++++ BEHAVIOUR +++++

	// Behavior for Window Resize
	win.onResize = function() { // makes the Layoutmanager update the sliders and editboxes to fit the new size
		win.layout.resize ();
	};

	// Behavior for ABSOLUTE ROTATION SLIDER Changing
	win.Tabs.Scatter.RotPnl.RotSliderCtrl.onChanging = function() { // Update the edittext with the current slider value. 
		var val = Math.round(win.Tabs.Scatter.RotPnl.RotSliderCtrl.value); 
		win.Tabs.Scatter.RotPnl.RotEdittext.text = val; 
	};

	// Behavior for ABSOLUTE ROTATION EDIT TEXT OnChange
	win.Tabs.Scatter.RotPnl.RotEdittext.onChange = function() { // Function corrects user input and updates slider
		with (win.Tabs.Scatter.RotPnl) { 
			var val_num = getFloat(RotEdittext.text); // getfloat converts the string to a good float
			var val_num_correct = gate(val_num, -180, 180); // if user enters a number smaller -180 or larger 180, then make -180 or 180
			RotEdittext.text = val_num_correct; // set edittext field to corrected value within -180 and 180
			updateSlider(RotSliderCtrl);  // setting slider to the rounded value of the edittext corresponding edittext in the sliders group
		}
	};

	// Behavior for RANDOM ROTATION MIN SLIDER Changing
	win.Tabs.Scatter.RndRotPnl.RndRotMin.RndRotMinSliderCtrl.onChanging = function() { 
		with (win.Tabs.Scatter.RndRotPnl.RndRotMin) { // Update the edittext with the current slider value.
			var val = Math.round(RndRotMinSliderCtrl.value); 
			RndRotMinEdittext.text = val; 
		}
	};

	// Behavior for RANDOM ROTATION MIN EDIT TEXT OnChange
	win.Tabs.Scatter.RndRotPnl.RndRotMin.RndRotMinEdittext.onChange = function() { 
		// Function corrects user input and updates slider
		with (win.Tabs.Scatter.RndRotPnl.RndRotMin) {
			var val_num = getFloat(RndRotMinEdittext.text); // getfloat converts the string to a good float
			var val_num_correct = gate(val_num, -180, 180); // if user enters a number smaller -180 or larger 180, then make -180 or 180
			RndRotMinEdittext.text = val_num_correct; // set edittext field to corrected value within -180 and 180
			updateSlider(RndRotMinSliderCtrl);  // setting slider to the rounded value of the edittext corresponding edittext in the sliders group
		}
	};

	// Behavior for RANDOM ROTATION MAX SLIDER Changing
	win.Tabs.Scatter.RndRotPnl.RndRotMax.RndRotMaxSliderCtrl.onChanging = function() { 
		with (win.Tabs.Scatter.RndRotPnl.RndRotMax) {  // Update the edittext with the current slider value. 
			var val = Math.round(RndRotMaxSliderCtrl.value); 
			RndRotMaxEdittext.text = val;  
		}
	}; 

	// Behavior for RANDOM ROTATION MAX EDIT TEXT onChange
	win.Tabs.Scatter.RndRotPnl.RndRotMax.RndRotMaxEdittext.onChange = function() { 
		with (win.Tabs.Scatter.RndRotPnl.RndRotMax) {	// Function corrects user input and updates slider
			var val_num = getFloat(RndRotMaxEdittext.text);
			var val_num_correct = gate(val_num, -180, 180); // if user enters a number smaller -180 or larger 180, then make -180 or 180
			RndRotMaxEdittext.text = val_num_correct; // set edittext field to corrected value within -180 and 180
			updateSlider(RndRotMaxSliderCtrl);  // setting slider to the rounded value of the edittext corresponding edittext in the sliders group
		}
	};

	// Behavior for RANDOM TRANSLATION X SLIDER Changing
	win.Tabs.Scatter.RndTransPnl.RndTransX.RndTransXSliderCtrl.onChanging = function() { 
		with (win.Tabs.Scatter.RndTransPnl.RndTransX) {  // Update the edittext with the current slider value. 
			var val = Math.round(RndTransXSliderCtrl.value); 
			RndTransXEdittext.text = val;  
		}
	}; 

	// Behavior for RANDOM TRANSLATION X EDIT TEXT onChange
	win.Tabs.Scatter.RndTransPnl.RndTransX.RndTransXEdittext.onChange = function() { 
		with (win.Tabs.Scatter.RndTransPnl.RndTransX) {	// Function corrects user input and updates slider
			var unitvalX = parseUnitValue(RndTransXEdittext.text, userHoriz);
			if (unitvalX != Math.round(unitvalX)) { // if unitval has decimals then...
				RndTransXEdittext.text = unitvalX.toFixed(3); // round number to be 3 decimals long
			}
			else RndTransXEdittext.text = unitvalX;
			updateSlider(RndTransXSliderCtrl);  // function setting slider to the rounded value of the edittext corresponding edittext in the sliders group
		}
	};

	// Behavior for RANDOM TRANSLATION Y SLIDER Changing
	win.Tabs.Scatter.RndTransPnl.RndTransY.RndTransYSliderCtrl.onChanging = function() { 
		with (win.Tabs.Scatter.RndTransPnl.RndTransY) {  // Update the edittext with the current slider value. 
			var val = Math.round(RndTransYSliderCtrl.value); 
			RndTransYEdittext.text = val;  
		}
	}; 

	// Behavior for RANDOM TRANSLATION Y EDIT TEXT onChange
	win.Tabs.Scatter.RndTransPnl.RndTransY.RndTransYEdittext.onChange = function() { 
		with (win.Tabs.Scatter.RndTransPnl.RndTransY) {	// Function corrects user input and updates slider
			var unitvalY = parseUnitValue(RndTransYEdittext.text, userVert);
			if (unitvalY != Math.round(unitvalY)) { // if unitval has decimals then...
				RndTransYEdittext.text = unitvalY.toFixed(3); // round number to be 3 decimals long
			}
			else RndTransYEdittext.text = unitvalY;
			updateSlider(RndTransYSliderCtrl);  // function setting slider to the rounded value of the edittext corresponding edittext in the sliders group
		}
	};

	// Behavior for RANDOM SCALE X MIN SLIDER Changing
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMin.RndScaleXMinSliderCtrl.onChanging = function() { 
		with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMin) {  // Update the edittext with the current slider value. 
			var val = Math.round(RndScaleXMinSliderCtrl.value); 
			RndScaleXMinEdittext.text = val;
		}
		if (scaleLinked) {
			with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMin) {
				RndScaleYMinEdittext.text = val;
				updateSlider(RndScaleYMinSliderCtrl);
			}
		}
	}; 

	// Behavior for RANDOM SCALE X MIN EDIT TEXT onChange
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMin.RndScaleXMinEdittext.onChange = function() { 
		with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMin) {	// Function corrects user input and updates slider
			var val_num = getFloat(RndScaleXMinEdittext.text);
			// any input correction, say for too high values would be here later. Not yet written.
			RndScaleXMinEdittext.text = val_num;
			updateSlider(RndScaleXMinSliderCtrl);  // function setting slider to the rounded value of the edittext corresponding edittext in the sliders group
		}
		if (scaleLinked) {
			with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMin) {
				RndScaleYMinEdittext.text = val_num;
				updateSlider(RndScaleYMinSliderCtrl);
			}
		}
	};

	// Behavior for RANDOM SCALE X MAX SLIDER Changing
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMax.RndScaleXMaxSliderCtrl.onChanging = function() { 
		with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMax) {  // Update the edittext with the current slider value. 
			var val = Math.round(RndScaleXMaxSliderCtrl.value); 
			RndScaleXMaxEdittext.text = val;  
		}
		if (scaleLinked) {
			with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMax) {
				RndScaleYMaxEdittext.text = val;
				updateSlider(RndScaleYMaxSliderCtrl);
			}
		}
	}; 

	// Behavior for RANDOM SCALE X MAX EDIT TEXT onChange
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMax.RndScaleXMaxEdittext.onChange = function() { 
		with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMax) {	// Function corrects user input and updates slider
			var val_num = getFloat(RndScaleXMaxEdittext.text);
			// any input correction, say for too high values would be here later. Not yet written.
			RndScaleXMaxEdittext.text = val_num;
			updateSlider(RndScaleXMaxSliderCtrl);  // function setting slider to the rounded value of the edittext corresponding edittext in the sliders group
		}
		if (scaleLinked) {
			with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMax) {
				RndScaleYMaxEdittext.text = val_num;
				updateSlider(RndScaleYMaxSliderCtrl);
			}
		}
	};

	// Behavior for RANDOM SCALE Y MIN SLIDER Changing
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMin.RndScaleYMinSliderCtrl.onChanging = function() { 
		with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMin) {  // Update the edittext with the current slider value. 
			var val = Math.round(RndScaleYMinSliderCtrl.value); 
			RndScaleYMinEdittext.text = val;  
		}
		if (scaleLinked) {
			with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMin) {
				RndScaleXMinEdittext.text = val;
				updateSlider(RndScaleXMinSliderCtrl);
			}
		}
	}; 

	// Behavior for RANDOM SCALE Y MIN EDIT TEXT onChange
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMin.RndScaleYMinEdittext.onChange = function() { 
		with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMin) {	// Function corrects user input and updates slider
			var val_num = getFloat(RndScaleYMinEdittext.text);
			// any input correction, say for too high values would be here later. Not yet written.
			RndScaleYMinEdittext.text = val_num;
			updateSlider(RndScaleYMinSliderCtrl);  // function setting slider to the rounded value of the edittext corresponding edittext in the sliders group
		}
		if (scaleLinked) {
			with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMin) {
				RndScaleXMinEdittext.text = val_num;
				updateSlider(RndScaleXMinSliderCtrl);
			}
		}
	};

	// Behavior for RANDOM SCALE Y MAX SLIDER Changing
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMax.RndScaleYMaxSliderCtrl.onChanging = function() { 
		with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMax) {  // Update the edittext with the current slider value. 
			var val = Math.round(RndScaleYMaxSliderCtrl.value); 
			RndScaleYMaxEdittext.text = val;  
		}
		if (scaleLinked) {
			with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMax) {
				RndScaleXMaxEdittext.text = val;
				updateSlider(RndScaleXMaxSliderCtrl);
			}
		}
	}; 

	// Behavior for RANDOM SCALE Y MAX EDIT TEXT onChange
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMax.RndScaleYMaxEdittext.onChange = function() { 
		with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMax) {	// Function corrects user input and updates slider
			var val_num = getFloat(RndScaleYMaxEdittext.text);
			// any input correction, say for too high values would be here later. Not yet written.
			RndScaleYMaxEdittext.text = val_num;
			updateSlider(RndScaleYMaxSliderCtrl);  // function setting slider to the rounded value of the edittext corresponding edittext in the sliders group
		}
		if (scaleLinked) {
			with (win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMax) {
				RndScaleXMaxEdittext.text = val_num;
				updateSlider(RndScaleXMaxSliderCtrl);
			}
		}
	};

	// Behavior for SCALE LINK BUTTON
	win.Tabs.Scatter.RndScalePnl.LinkScaleButton.onClick = function() { // switching "scaledLinked" vice versa
		if (scaleLinked) {
			scaleLinked = false;
			win.Tabs.Scatter.RndScalePnl.LinkScaleButton.image = images.unlinkScale;
			win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXImage.image = images.scaleX;
			enableUI(win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY, true);
		} 
		else {  // go into "proportional-scale" mode
			scaleLinked = true;
			win.Tabs.Scatter.RndScalePnl.LinkScaleButton.image = images.linkScale;
			 // if linking gets enabled then equalize the y-fields and sliders to the x-fields and sliders and then disable the y-Sliders
			 // we'll be using only the scaleX slides then to set our minimum and maximum proportional scale
			with (win.Tabs.Scatter.RndScalePnl.RndScale) {
				RndScaleY.RndScaleYMin.RndScaleYMinEdittext.text = RndScaleX.RndScaleXMin.RndScaleXMinEdittext.text;
				updateSlider(RndScaleY.RndScaleYMin.RndScaleYMinSliderCtrl);
				RndScaleY.RndScaleYMax.RndScaleYMaxEdittext.text = RndScaleX.RndScaleXMax.RndScaleXMaxEdittext.text;
				updateSlider(RndScaleY.RndScaleYMax.RndScaleYMaxSliderCtrl);
				RndScaleX.RndScaleXImage.image = images.scaleXY;
				enableUI(RndScaleY, false);
			}
		}
	};

	// Define behavior for the RESET button  
	win.buttons.ResetButton.onClick = function ()	{
		zeroEdittexts(win); // function enters 0 recursivly in all edittexts of win
		updateSliders(win); // function makes the Sliders the value of their (grouped) editboxes.
	};

	// Define behavior for the SETTING button  
	win.buttons.SettingsButton.onClick = function ()	{
		with (win.Tabs) {
			if (SettingsPnl.visible == false) {	
				SettingsPnl.visible = true;	
				Scatter.visible = false; 
			}
			else { 
				SettingsPnl.visible = false;	
				Scatter.visible = true;	
			}
		}
	}; 

	// Define behavior for the "SCATTER!" button  
	win.buttons.scatterButton.onClick = function ()	{
		var Rot = getFloat(win.Tabs.Scatter.RotPnl.RotEdittext.text);
		var minRot = getFloat(win.Tabs.Scatter.RndRotPnl.RndRotMin.RndRotMinEdittext.text);
		var maxRot = getFloat(win.Tabs.Scatter.RndRotPnl.RndRotMax.RndRotMaxEdittext.text);
		var transX = getFloat(win.Tabs.Scatter.RndTransPnl.RndTransX.RndTransXEdittext.text);
		var transY = getFloat(win.Tabs.Scatter.RndTransPnl.RndTransY.RndTransYEdittext.text);
		var scaleXmin = getFloat(win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMin.RndScaleXMinEdittext.text);
		var scaleXmax = getFloat(win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMax.RndScaleXMaxEdittext.text);
		var scaleYmin = getFloat(win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMin.RndScaleYMinEdittext.text);
		var scaleYmax = getFloat(win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMax.RndScaleYMaxEdittext.text);
		scatter(Rot, minRot, maxRot, transX, transY, scaleXmin, scaleXmax, scaleYmin, scaleYmax, scaleLinked, userHoriz, userVert); 
	}; 

	// Define behavior for the "Un-Scatter" button  
	win.buttons.unscatterButton.onClick = function ()	{ 
		unscatter();
	};

	// Define behavior for the "Done" button  
	win.buttons.doneButton.onClick = function ()	{
		PrepPrefsFromVariables(win, Preferences);
		writePreferences(); 
		win.close(); 
	};

	// Display the window 
	if (Preferences.winframeLocation[0] == 0 && Preferences.winframeLocation[1] == 0) { 
		win.center(); // if no prefs exists the window would be in [0,0] so we better center it
	} 
	win.show();
} // END of ScatterSelected.prototype.run FUNCTION


function scatter (Rot, minRot, maxRot, transX, transY, scaleXmin, scaleXmax, scaleYmin, scaleYmax, scaleLinked, userHoriz, userVert) {
	if (nothingSelected()) return;
	// define standart values for a complete unscatter label
	var myAnchor = app.layoutWindows[0].transformReferencePoint;
	var myRandomAngle = 0;
	var rndtransXpt = 0;
	var rndtransYpt = 0;
	var rndscaleX = 1;
	var rndscaleY = 1;
	var needsUnscatterLabel = false;
	var myItems = app.selection; 
	for (var j = myItems.length - 1; j >= 0; j--) { 
		var myItem = myItems[j];
		var myMatrix = app.transformationMatrices.add();
		// Scaling  first! If matrix would be rotated first, then the rotated MATRIX would become sheared upon scaling on X or Y		
		if(scaleXmin != 100 || scaleXmax != 100 || scaleYmin != 100 || scaleYmax != 100) {
			rndscaleX = ((Math.random()*(scaleXmax - scaleXmin)) + scaleXmin)/100;
			rndscaleY = ((Math.random()*(scaleYmax - scaleYmin)) + scaleYmin)/100;
			if (scaleLinked) rndscaleY = rndscaleX;  // for proportional scale, make X and Y the same;
			myMatrix = myMatrix.scaleMatrix(rndscaleX, rndscaleY);
			hasTransformation = true;
		}		
		// fixed rotation of matrix
		if(Math.abs(Rot) != 0) { // if user entered a value for absolut rotation different from Zero
			myMatrix = myMatrix.rotateMatrix(Rot); // For absolute Rotation MAKE myMatrix = myMatrix.rotateMatrix(Rot-myItem.rotationAngle); 
			hasTransformation = true;
		}
		// random rotate matrix
		if((Math.abs(minRot)+Math.abs(maxRot)) != 0) { // if user entered a value for min or max different from zero, then...
			myRandomAngle = (Math.random()*(maxRot - minRot)) + minRot;
			myMatrix = myMatrix.rotateMatrix(myRandomAngle);
			hasTransformation = true;
		}
		// random translate (move) matrix
		if((Math.abs(transX)+Math.abs(transY)) != 0) { // if user entered a value for x-Translation or y-Translation different from zero, then...
			// if 10 is entered then it gets random values between -10 and 10
			var rndtransX = 2*((Math.random()*transX)-0.5*transX);
			var rndtransY = 2*((Math.random()*transY)-0.5*transY);
			rndtransXpt = parseUnitValue(rndtransX + ' ' + userHoriz, "pt");
			rndtransYpt = parseUnitValue(rndtransY + ' ' + userVert, "pt");
			// convert the current values into the unit "points" - because translateMatrix always moves objects in points
			myMatrix = myMatrix.translateMatrix(rndtransXpt, rndtransYpt);
			hasTransformation = true;
		}	
		// do the transformation
		if (hasTransformation) {
			try {
				myItem = myItem.transform(CoordinateSpaces.innerCoordinates,  myAnchor, myMatrix);
				addUnscatterLabel(myItems[j], myAnchor, Rot+myRandomAngle, rndtransXpt, rndtransYpt, rndscaleX, rndscaleY);
			} catch(e) { }
		}
	} // end "for all selected items"...
}

function hasUnscatterLabel(myObj) {
	try { 
		var evaluated = eval(myObj.extractLabel("UnscatterLabel")); 
		if (evaluated) return true;	 
		else return false;
	} catch (e) {alert(e)}
}

function addUnscatterLabel(myObj, myAnchor, rot, rndtransXpt, rndtransYpt, rndscaleX, rndscaleY) {
	// The unscatter label is an array of objects. Each object in the label is a record of one scatter-transformation. Each time we scatter an object, one undo-information is added to the array. Each time we unscatter the last item is removed.
	ValuesToUndo = new Array();
	if (hasUnscatterLabel(myObj)) { // If the object already has an unscatter label then get it, so we can add one item to it
		try { 
			var evaluated = eval(myObj.extractLabel("UnscatterLabel")); 
			if (evaluated) ValuesToUndo = evaluated;	 
		} catch (e) {alert(e)}	
	}
	ValueToUndo = new Object(); // create another unscatter information
	ValueToUndo.anchor = myAnchor;
	ValueToUndo.rotation = rot;
	ValueToUndo.transX =rndtransXpt;
	ValueToUndo.transY = rndtransYpt;
	ValueToUndo.scaleX = rndscaleX;
	ValueToUndo.scaleY = rndscaleY;
	ValuesToUndo.push(ValueToUndo); // add it
	try {myObj.insertLabel("UnscatterLabel", ValuesToUndo.toSource());}
	catch(e) {alert(e)}
}

function removeUnscatterLabel(myObj) { // labels can be removed by writing an empty string
	try {myObj.insertLabel("UnscatterLabel", "");} 
	catch(e) {alert(e)}
}

function unscatter () {
	
	if (nothingSelected()) return;
	var myItems = app.selection; 
	for (var j = myItems.length - 1; j >= 0; j--) {
		if (hasUnscatterLabel(myItems[j])) {
			var hasUnscattered = false;
			try { 
				var evaluated = eval(myItems[j].extractLabel("UnscatterLabel")); 
				if (evaluated) {
					ValuesToUndo = evaluated;	 
					ValueToUndo = ValuesToUndo.pop(); // get last undo-item from the unscatter array and remove it from the array
				} 
			} catch(e) {alert(e)}
			// UN-TRANSLATE the last scatter
			// Has to go in two steps unfortunatly.  First un-rotation and un-transform THEN un-scaling. The objects would get skewed otherwise.
			try {
				var myMatrix = app.transformationMatrices.add();
				myMatrix = myMatrix.translateMatrix(-ValueToUndo.transX, -ValueToUndo.transY);
				myMatrix = myMatrix.rotateMatrix(-ValueToUndo.rotation);
				myItems[j].transform(CoordinateSpaces.innerCoordinates,  ValueToUndo.anchor, myMatrix);
				// in order to undo the scaling, for instance a scaling down to 0.25 then we need to scale back up to 4. Thats what "100/Value/100" does
				var myScaleMatrix = app.transformationMatrices.add({horizontalScaleFactor:(100/ValueToUndo.scaleX)/100, verticalScaleFactor: (100/ValueToUndo.scaleY)/100});
				myItems[j].transform(CoordinateSpaces.innerCoordinates,  ValueToUndo.anchor, myScaleMatrix);
				hasUnscattered = true;
			} catch(e) {alert ("This object could not be unscattered - it would leave the pasteboard. \n You can try to manually move it away from the pasteboard edges and unscatter again.");}
			if (hasUnscattered) {
				try {myItems[j].insertLabel("UnscatterLabel", ValuesToUndo.toSource());} // re-insert the shortened-by-1 unscatter array - do this only if the transformation worked
				catch(e) {alert(e)}
				// if the last unscatter-item got popped from the array above then the array is empty and the label better be removed altogether
				if (ValuesToUndo.length == 0) removeUnscatterLabel(myItems[j]); 
			}
		} // end of "if hasUnscatterLabel"
	} // end "for all selected Items"
}

function updateSlider(mySlider) { // updates the slider with the edittext in its group
	var SliderGroupItems = mySlider.parent.children;
	for (var i = SliderGroupItems.length - 1; i >= 0; i--) {  
		var SliderGroupItem = SliderGroupItems[i];
		if (SliderGroupItem.type == 'edittext') { 
			mySlider.value = Math.round(SliderGroupItem.text);
		}
	}
}

function updateSliders(ScriptUIobj) {
	var ScriptUIobjChildren = ScriptUIobj.children;
	for (var i = ScriptUIobjChildren.length - 1; i >= 0; i--) {  // for all children do...
		var ScriptUIobjChild = ScriptUIobjChildren[i];
		if (ScriptUIobjChild.type == 'slider') { // if child is a slider then updates the slider with the edittext in its group
			updateSlider(ScriptUIobjChild);
		}
		updateSliders(ScriptUIobjChild); // recurse down through all children to find all sliders
	}
}

function enableUI(ScriptUIobj, enableState) {
	var ScriptUIobjChildren = ScriptUIobj.children;
	for (var i = ScriptUIobjChildren.length - 1; i >= 0; i--) {  // for all children do...
		var ScriptUIobjChild = ScriptUIobjChildren[i];
		ScriptUIobjChild.enabled = enableState;
		updateSliders(ScriptUIobjChild); // recurse down through all children to find all sliders
	}
}

function zeroEdittexts(ScriptUIobj) {
	var ScriptUIobjChildren = ScriptUIobj.children;
	for (var i = ScriptUIobjChildren.length - 1; i >= 0; i--) {  // for all children (beeing the panels and groups of WIN) do...
		var ScriptUIobjChild = ScriptUIobjChildren[i];
		if (ScriptUIobjChild.type == 'edittext') { // if child is an edittext then ...
			try {  
				if (ScriptUIobjChild.percent) { // see if the editbox has the element "percent" set true then make it 100(%)
					ScriptUIobjChild.text = 100;
				} else ScriptUIobjChild.text = 0; // else set to 0
			} catch (e) { 
					// do nothing on error 
			};
		}
		zeroEdittexts(ScriptUIobjChild); // recurse down through all children to find all edittexts
	}
}

function getUnit(mu) {
	var str = new String;
	switch (mu) {
		case MeasurementUnits.AGATES: str = "ag"; break;
		case MeasurementUnits.CENTIMETERS: str = "cm"; break;
		case MeasurementUnits.CICEROS: str = "ci"; break;
		case MeasurementUnits.CUSTOM: str = "cstm"; break;
		case MeasurementUnits.INCHES: str = "in"; break;
		case MeasurementUnits.INCHES_DECIMAL: str = "in"; break;
		case MeasurementUnits.MILLIMETERS: str = "mm"; break;
		case MeasurementUnits.PICAS: str = "pc"; break;
		case MeasurementUnits.POINTS: str = "pt"; break;
	}
	return str;
}

function gate (g, floor, ceiling) { // makes a number be inside min and max values
	g = Math.min(g, ceiling); // if number larger than ceiling, return ceiling
	g = Math.max(g, floor); // if number smaller than floor, return floor
	return g;
}

function getFloat (s) { // converts a string to a number - empty string and bad string to Zero
	if (s == undefined || s == '' || s.length == 0) { s = '0' } // if string empty make Zero
	s = s.split(",").join("."); //  convert comma to point
	var f = parseFloat(s); //convert to float, eventually truncate before any character
	if (isNaN(f)) { f = 0 } // if user entered string instead of a number, return 0;
	return f;
}

function parseUnitValue (s, baseUnit) { 
	// converts a string, for instance "-10.1 yard" or "0,23 mm"  or ".3 pt" to a unitvalue. And then returns this value converted to baseUnit
	// for instance if s literally is "1 inch" or "1in" and baseUnit is "mm" the function will return 25.4
	// returns zero if the string doesn't parse to a unitValue!
	if (s == undefined || s == '' || s.length == 0) { s = '0' } // if string empty make Zero
	var regex = /\+*(\-*\d*[\.|,]?\d*\s*)(in|inch|inches|ft|foot|feet|yd|yard|yards|mi|mile|miles|mm|millimeter|millimeters|cm|centimeter|centimeters|m|meter|meters|km|kilometer|kilometers|pt|point|points|pc|pica|picas|ci|cicero|ciceros)?/gi; 
	var myMatch = s.match(regex);
	try { 
		var stringIsValid = ( s ==myMatch[ 0 ] ); // compare the string to the regular expression matched string. If they are equal then the string fits the required form for a unitvalue.
	} 
	catch( e ) { 
		var stringIsValid = false; // if the string is not valid, something in the string was bad. Perhaps it was "+-10in" or "mommy" or "10i". Its not suitable for a unitvalue.
	}
	if (stringIsValid) {
		var sVal = s.replace(regex, RegExp.$1).split(",").join(".");  // get the real value part of the string. Also convert comma to point;
		var sUnit = s.replace(regex, RegExp.$2); // get the unit part of the string.
		if (sUnit == undefined || sUnit == '') { sUnit = baseUnit; }  // this is for the case when the string is a number only, like "0", or "10.2", We then assume the user wanted the baseunit.
	}
	else { // if String doesn't parse as a unitvalue, make Zero
		alert("Unknown Unit. Try: \n in, inch, inches, ft, foot, feet, yd, yard, yards, mi, mile, miles, pt, point, points, pc, pica, picas, ci, cicero, ciceros, \n mm, millimeter, millimeters, cm, centimeter, centimeters, m, meter, meters, km, kilometer, kilometers :)");
		var sVal = 0;   
		var sUnit = baseUnit;
	}
	var myUnitValue = new UnitValue(sVal, sUnit); // create a unitvalue object...
	return myUnitValue.as(baseUnit); // ...but output its value only - converted to baseUnit
}
 
function nothingSelected() { 
	if (app.documents.length == 0 || app.selection.length == 0) { 
		alert("Please select an object."); return true; 
	} 
	return false; 
} 
 
function initPreferences() { 
	scriptFile = File($.fileName); 
	scriptName = scriptFile.name.match(/^.*\./g).toString(); 
	preferencesFile = File(scriptFile.parent.path.toString() + "/Preferences/" + scriptName + "preferences"); 
	preferencesFile.encoding = "UTF-8"; 
	Preferences = new Object();
} 
 
function readPreferences() { 
	if (preferencesFile.open("r")) { 
		try { 
			var evaluated = eval(preferencesFile.read()); 
			if (evaluated) Preferences = evaluated;	 
		} catch (e) {} 
	}  
	preferencesFile.close(); 
} 
 
function writePreferences() { 
	if (!preferencesFile.parent.exists) {preferencesFile.parent.create();} 
	if (preferencesFile.open("w")) { 
		preferencesFile.writeln(Preferences.toSource()); 
	} 
	preferencesFile.close(); 
}

function PrepVariablesFromPrefs (win, Preferences) {
	win.Tabs.Scatter.RotPnl.RotEdittext.text = Preferences.RotEdittextPref;
	win.Tabs.Scatter.RndRotPnl.RndRotMin.RndRotMinEdittext.text = Preferences.RndRotMinEdittextPref;
	win.Tabs.Scatter.RndRotPnl.RndRotMax.RndRotMaxEdittext.text = Preferences.RndRotMaxEdittextPref;
	win.Tabs.Scatter.RndTransPnl.RndTransX.RndTransXEdittext.text = Preferences.RndTransXEdittextPref;
	win.Tabs.Scatter.RndTransPnl.RndTransY.RndTransYEdittext.text = Preferences.RndTransYEdittextPref;
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMin.RndScaleXMinEdittext.text = Preferences.RndScaleXMinEdittextPref;
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMax.RndScaleXMaxEdittext.text = Preferences.RndScaleXMaxEdittextPref;
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMin.RndScaleYMinEdittext.text = Preferences.RndScaleYMinEdittextPref;
	win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMax.RndScaleYMaxEdittext.text = Preferences.RndScaleYMaxEdittextPref;
	win.frameLocation = [Preferences.winframeLocation.x, Preferences.winframeLocation.y];
}
function PrepPrefsFromVariables (win, Preferences) {
	Preferences.RotEdittextPref = win.Tabs.Scatter.RotPnl.RotEdittext.text;
	Preferences.RndRotMinEdittextPref = win.Tabs.Scatter.RndRotPnl.RndRotMin.RndRotMinEdittext.text;
	Preferences.RndRotMaxEdittextPref = win.Tabs.Scatter.RndRotPnl.RndRotMax.RndRotMaxEdittext.text;
	Preferences.RndTransXEdittextPref = win.Tabs.Scatter.RndTransPnl.RndTransX.RndTransXEdittext.text; 
	Preferences.RndTransYEdittextPref = win.Tabs.Scatter.RndTransPnl.RndTransY.RndTransYEdittext.text;
	Preferences.RndScaleXMinEdittextPref =win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMin.RndScaleXMinEdittext.text;
	Preferences.RndScaleXMaxEdittextPref = win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleX.RndScaleXMax.RndScaleXMaxEdittext.text;
	Preferences.RndScaleYMinEdittextPref = win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMin.RndScaleYMinEdittext.text;
	Preferences.RndScaleYMaxEdittextPref = win.Tabs.Scatter.RndScalePnl.RndScale.RndScaleY.RndScaleYMax.RndScaleYMaxEdittext.text;
	Preferences.winframeLocation = win.frameLocation;
}
function makeUIimages() {
	var uiImages = new Object();
	var scriptFile = File($.fileName); 
	try {
		uiImages.reset = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "reset.png"));
		uiImages.settings = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "settings.png"));
		uiImages.rotate = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "rotate.png"));
		uiImages.rotmin = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "rotatemin.png"));
		uiImages.rotmax = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "rotatemax.png"));
		uiImages.transX = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "transx.png"));
		uiImages.transY = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "transy.png"));
		uiImages.scaleX = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "scalex.png"));
		uiImages.scaleY = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "scaley.png"));
		uiImages.scaleXY = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "scalexy.png"));
		uiImages.unlinkScale = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "unlink.png"));
		uiImages.linkScale = ScriptUI.newImage(File(scriptFile.parent.path.toString() + "/Preferences/" + "link.png"));
	} catch(e) {
		alert("One or more UI components missing.\n\nPlease follow install instructions.");
		return null;
	}
	return uiImages
}
/** 
 "main program": construct an anonymous instance and run it 
  as long as we are not unit-testing this snippet. 
*/ 
if(typeof(ScatterSelected_unitTest) == "undefined") { 
    new ScatterSelected().run(); 
} 